MethodRankHelper (Groovy 4.0.10)

Package: org.codehaus.groovy.runtime

## [Java] Class MethodRankHelper

- org.codehaus.groovy.runtime.MethodRankHelper

-     public class MethodRankHelper
      extends Object

  Utility class for MissingMethodException, MissingPropertyException etc. This class contains methods assisting in ranking and listing probable intended methods/fields when an exception is thrown.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static int` | `DL_CASE` |
    `static int` | `DL_DELETE` |
    `static int` | `DL_SUBSTITUTION` |
    `static int` | `DL_TRANSPOSITION` |
    `static int` | `MAX_CONSTRUCTOR_SCORE` |
    `static int` | `MAX_FIELD_SCORE` |
    `static int` | `MAX_METHOD_SCORE` |
    `static int` | `MAX_RECOMENDATIONS` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected static Class` | `boxVar(Class c)` If c is a primitive class this method returns a boxed version otherwise c is returned.
    `` | `public static int` | `damerauLevenshteinDistance(Object[] s, Object[] t)` This is an implementation of DL distance between two Object arrays instead of character streams.
    `` | `public static int` | `delDistance(CharSequence s, CharSequence t)` This is a slightly modified version of the Damerau Levenshtein distance algorithm.
    `` | `public static String` | `getConstructorSuggestionString(Class type, Object[] arguments)` Returns a string detailing possible solutions to a missing constructor if no good solutions can be found an empty string is returned.
    `` | `public static String` | `getMethodSuggestionString(String methodName, Class type, Object[] arguments)` Returns a string detailing possible solutions to a missing method if no good solutions can be found an empty string is returned.
    `` | `public static String` | `getPropertySuggestionString(String fieldName, Class type)` Returns a string detailing possible solutions to a missing field or property if no good solutions can be found an empty string is returned.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final int DL_CASE

    - #### public static final int DL_DELETE

    - #### public static final int DL_SUBSTITUTION

    - #### public static final int DL_TRANSPOSITION

    - #### public static final int MAX_CONSTRUCTOR_SCORE

    - #### public static final int MAX_FIELD_SCORE

    - #### public static final int MAX_METHOD_SCORE

    - #### public static final int MAX_RECOMENDATIONS

  - ### Method Detail

    - #### protected static Class boxVar(Class c)

      If c is a primitive class this method returns a boxed version otherwise c is returned. In java 1.5 this can be simplified thanks to the Type class.

      Parameters:
        c
      Returns:
        a boxed version of c if c can be boxed, else c

    - #### public static int damerauLevenshteinDistance(Object[] s, Object[] t)

      This is an implementation of DL distance between two Object arrays instead of character streams. The objects are compared using their equals method. No objects may be null. This implementation is based on Chas Emerick's implementation of Levenshtein Distance for jakarta commons.

      Parameters:
        `s` - an Object array
        `t` - this array is compared to s
      Returns:
        the edit distance between the two arrays

    - #### public static int delDistance(CharSequence s, CharSequence t)

      This is a slightly modified version of the Damerau Levenshtein distance algorithm. It has an additional test to see if a character has switched case, in the original algorithm this counts as a substitution. The "cost" for a substitution is given as 10 instead of 1 in this version, this enables transpositions and case modifications to have a lower cost than substitutions. Currently the lowercase versions of t_j and s_i isn't cached, its probable that some speed could be gained from this. This version is based on Chas Emerick's implementation of Levenshtein Distance for jakarta commons.

      Parameters:
        `s` - a CharSequence
        `t` - the CharSequence to be compared to s
      Returns:
        a value representing the edit distance between s and t

    - #### public static String getConstructorSuggestionString(Class type, Object[] arguments)

      Returns a string detailing possible solutions to a missing constructor if no good solutions can be found an empty string is returned.

      Parameters:
        `arguments` - the arguments passed to the constructor
        `type` - the class on which the constructor is invoked
      Returns:
        a string with probable solutions to the exception

    - #### public static String getMethodSuggestionString(String methodName, Class type, Object[] arguments)

      Returns a string detailing possible solutions to a missing method if no good solutions can be found an empty string is returned.

      Parameters:
        `methodName` - the name of the method that doesn't exist
        `type` - the class on which the method is invoked
        `arguments` - the arguments passed to the method
      Returns:
        a string with probable solutions to the exception

    - #### public static String getPropertySuggestionString(String fieldName, Class type)

      Returns a string detailing possible solutions to a missing field or property if no good solutions can be found an empty string is returned.

      Parameters:
        `fieldName` - the missing field
        `type` - the class on which the field is sought
      Returns:
        a string with probable solutions to the exception